//	Oracle VM VirtualBox̃}V[̎擾
//	Visual C++ 2008/2013

#include <windows.h>
#include <shlobj.h>
#include <commctrl.h>
#include <tchar.h>
#include "resource.h"

#if _MSC_VER<=1100
	#define _tcscat_s(dtc,sz,src) _tcscat(dtc,src)
#endif

//	z}V[擾_CAO{bNXvV[W[
LRESULT CALLBACK GetVmDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

int WINAPI _tWinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst, TCHAR* lpsCmdLine, int nCmdShow){
	TCHAR name[MAX_PATH];
	if (DialogBoxParam(hCurInst, TEXT("GetVmDLG1"), 0, (DLGPROC)GetVmDlgProc, (LPARAM)name) == TRUE)
		MessageBox(0, name, _TEXT("z}V["), MB_OK);
	return (int)0;
}


//	z}V[擾_CAO{bNXvV[W[

LRESULT CALLBACK GetVmDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	static TCHAR* vm_name = 0;
	int num;
	switch (msg) {
	case WM_INITDIALOG:{
		vm_name = (TCHAR*)lParam;
		num = 0;
#if 1100<_MSC_VER
		TCHAR path[MAX_PATH];
		if (SHGetSpecialFolderPath(NULL, path, CSIDL_PROFILE, 0) == TRUE){
			_tcscat_s(path, sizeof(path) / sizeof(TCHAR), _TEXT("\\VirtualBox VMs\\*.*"));
			WIN32_FIND_DATA FindFileData;
			HANDLE hFind;

			hFind = FindFirstFile(path, &FindFileData);
			if (hFind != INVALID_HANDLE_VALUE){
				do{
					if (FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
						if (_tcscmp(FindFileData.cFileName, _TEXT(".")) && _tcscmp(FindFileData.cFileName, _TEXT(".."))){
							SendMessage(GetDlgItem(hDlg, IDC_COMBOBOX), CB_INSERTSTRING, num, (LPARAM)FindFileData.cFileName);	//R{{bNXɃACe̐ݒ
							++num;
						}
					}
				} while (FindNextFile(hFind, &FindFileData));
				FindClose(hFind);
			}
		}
#endif
		if (num==0){	//	z}V[݂Ȃꍇ
			EndDialog(hDlg, FALSE);
		}else{
			SetWindowText(GetDlgItem(hDlg, IDC_LABEL), _TEXT("z}V[IĂB"));
			SendMessage(GetDlgItem(hDlg, IDC_COMBOBOX), CB_SETCURSEL, 0, (LPARAM)0);	//	ɑIACeI
		}
		return TRUE;
	}
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			GetWindowText(GetDlgItem(hDlg, IDC_COMBOBOX), vm_name, MAX_PATH);
			EndDialog(hDlg, TRUE);
			return TRUE;
		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			return FALSE;
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}
	return TRUE;
}

